Name:       symbiotic
Version:    7.0.0.20200810.181541.ga104a8c
Release:    4%{?dist}
Summary:    Tool for analysis of sequential computer programs written in C
License:    Free
URL:        https://github.com/staticafi/%{name}
Source0:    %{name}-%{version}.tar.xz
Source1:    symbiotic2cs.py
Source2:    csexec-symbiotic.sh
Patch0:     build.patch
Patch1:     hotfix.patch

BuildRequires: gcc
BuildRequires: cmake
BuildRequires: jsoncpp-devel
BuildRequires: llvm-devel
BuildRequires: llvm-static
BuildRequires: clang
BuildRequires: glibc-devel
BuildRequires: glibc-devel(x86-32)
BuildRequires: ncurses-devel
BuildRequires: python3
BuildRequires: sqlite-devel
BuildRequires: z3-devel
BuildRequires: zlib-static

Requires: clang
Requires: llvm

%description
Symbiotic is a tool for analysis of sequential computer programs written in the programming language C. It can check all common safety properties like assertion violations, invalid pointer dereference, double free, memory leaks, etc.

%prep
%autosetup -p1

%build
export SYMBIOTIC_VERSION=630bd29942435f8b20c3f2d1f2161f1cf79341d4
export DG_VERSION=8fd2192674b2295881f1cc6f47b1a7d9bad5e7da
export SBT_SLICER_VERSION=ce747eca2b9fc930b33850ad8e20c8100118f299
export INSTRUMENTATION_VERSION=ff5d8b3f513855d3bffb2efb04aa91c6c4a6f66b
export KLEE_VERSION=63cf2760fe0c8793261ac1e204181daa3fc9425d

%set_build_flags
./system-build.sh %{?_smp_mflags}

%install
mkdir -p %{buildroot}/opt/%{name}
cp -pr install/* %{buildroot}/opt/%{name}

mkdir -p %{buildroot}%{_bindir}
install -m 755 %{SOURCE1} %{buildroot}%{_bindir}/symbiotic2cs
install -m 755 %{SOURCE2} %{buildroot}%{_bindir}/csexec-symbiotic
ln -sf /opt/symbiotic/bin/symbiotic %{buildroot}%{_bindir}/symbiotic

%files
/opt/%{name}/
%{_bindir}/%{name}
%{_bindir}/symbiotic2cs
%{_bindir}/csexec-symbiotic
